# file with help functions to implement.

function modclienthelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm modclient [OPTARGS]" "Change Client properties"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to change by NAME"
  printf '%-25s %-45s\n' "-I|--id <CLI_ID>" "Select Client to change by ID"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-i|--ipaddr <IP>" "Set new IP address to client"
  printf '%-25s %-45s\n' "-M|--macaddr <MAC>" "Set new MAC address to client"
  printf '%-25s %-45s\n' "-n|--netname <NET>" "Assign new NETWORK to client"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm modclient -c|--client <cli_name> [ options ]\n"
  printf "  or\n"
  printf "drlm modclient -I|--id <cli_id> [ options ]\n"
  printf "\n"
}

function addclienthelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm addclient [OPTARGS]" "Add Client to database"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-i|--ipaddr <IP>[/<CIDR>]" "Client IP address"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client name to add"
  printf '%-25s %-45s\n' "-M|--macaddr <MAC>" "Client MAC address"
  printf "\n"
  printf "$(tput bold)InstallClient Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-I|--installclient" "Install ReaR and configure client to be managed by DRLM"
  printf '%-25s %-45s\n' "-u|--user <USER>" "User with admin privileges to install and configure software"
  printf '%-25s %-45s\n' "-U|--url_rear <URL_REAR>" "rpm or deb package for especific distro for example http://download.opensuse.org/repositories/Archiving:/Backup:/Rear/Debian_7.0/all/rear_1.17.2_all.deb"
  printf '%-25s %-45s\n' "-r|--repo" "Force to install ReaR package from oficial distro repositories"
  printf '%-25s %-45s\n' "-C|--config" "ReaR and the required packages for ReaR will not be installed, but the client will be configured. Useful when the client has no connection to the internet or repository."
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm addclient -i|--ipaddr <cli_ip>/<cidr>\n"
  printf "  or\n"
  printf "drlm addclient -c|--client <cli_name> -i|--ipaddr <cli_ip> -M|--macaddr <cli_mac>\n"
  printf "$(tput bold)Example with installClient:\n$(tput sgr0)"
  printf "drlm addclient -c|--client <cli_name> -i|--ipaddr <cli_ip> -M|--macaddr <cli_mac> -I|--installclient -u|--user <user> -U|--url_rear <URL ReaR package>\n"
  printf "\n"
}

function addnetworkhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm addnetwork [OPTARGS]" "Add Network to database"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-n|--netname <NET_NAME>" "Select Network name to add"
  printf '%-25s %-45s\n' "-g|--gateway <GATEWAY>" "Network gateway address"
  printf '%-25s %-45s\n' "-m|--mask <MASK>" "Network mask"
  printf '%-25s %-45s\n' "-s|--server <SERVER>" "Network server address"
  printf '%-25s %-45s\n' "-i|--ipaddr <IP>" "Network IP address"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Example:\n$(tput sgr0)"
  printf "drlm addnetwork -s <net_server_ip>\n"
  printf "  or\n"
  printf "drlm addnetwork -i <net_ip> -n <net_name>\n"
  printf "  or\n"
  printf "drlm addnetwork -n <net_name> -g <net_gateway> -m <net_mask> -s <server_ip>\n"

  printf "\n"
}

function bkpmgrhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm bkpmgr [OPTARGS]" "Backup Manager"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client name to modify backup"
  printf '%-25s %-45s\n' "-I|--id <BKP_ID>" "Select Backup ID to modify"
  printf '%-25s %-45s\n' "-e|--enable" "Enable read only Backup or Snap"
  printf '%-25s %-45s\n' "-w|--write" "Enable local write Backup or Snap"
  printf '%-25s %-45s\n' "-W|--full-write" "Enable local and remote write Backup or Snap"
  printf '%-25s %-45s\n' "-d|--disable" "Disable Backup or Snap"
  printf '%-25s %-45s\n' "-H" "Toggle hold backup or Snap"
  printf '%-25s %-45s\n' "--hold-on" "Hold ON Backup or Snap"
  printf '%-25s %-45s\n' "--hold-off" "Hold OFF Backup or Snap"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm bkmgr -d -c|--client <cli_name> [ options ]\n"
  printf "  or\n"
  printf "drlm bkmgr -e -c|--client <cli_name> -I|--id <bkp_id> [ options ]\n"
  printf "\n"
}

function delclienthelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm delclient [OPTARGS]" "Delete Client fom Database"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to delete by NAME"
  printf '%-25s %-45s\n' "-I|--id <CLI_ID>" "Select Client to delete by ID"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm delclient -c|--client <cli_name>\n"
  printf "  or\n"
  printf "drlm delclient -I|--id <cli_ID>\n"
  printf "\n"
}

function delnetworkhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm delnetwork [OPTARGS]" "Delete Network fom Database"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-n|--netname <NET_NAME>" "Select Network to delete by NAME"
  printf '%-25s %-45s\n' "-I|--id <NET_ID>" "Select Network to delete by ID"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm delnetwork -n|--netname <net_name>\n"
  printf "  or\n"
  printf "drlm delnetwork -I|--id <net_id>\n"
  printf "\n"
}

function instclienthelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm instclient [OPTARGS]" "Install REAR to a remote client"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to install REAR by name"
  printf '%-25s %-45s\n' "-I|--id <CLI_ID>" "Select Client to intall REAR by ID"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-u|--user <USER>" "User with admin privileges to install and configure software"
  printf '%-25s %-45s\n' "-U|--url_rear <URL_REAR>" "rpm or deb package for especific distro for example http://download.opensuse.org/repositories/Archiving:/Backup:/Rear/Debian_7.0/all/rear_1.17.2_all.deb"
  printf '%-25s %-45s\n' "-r|--repo" "Force to install ReaR package from oficial distro repositories"
  printf '%-25s %-45s\n' "-C|--config" "ReaR and the required packages for ReaR will not be installed, but the client will be configured. Useful when the client has no connection to the internet or repository."
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm instclient -c|--client <cli_name>\n"
  printf "  or\n"
  printf "drlm instclient -I|--id <cli_id> [ options ]\n"
  printf "\n"
}

function listbackuphelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm listbackup [OPTARGS]" "List DRLM database backups"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to list its backups"
  printf '%-25s %-45s\n' "-A|--all" "List all backups"
  printf '%-25s %-45s\n' "-p|--pretty" "Marks those backups that might have failed with colors"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm listbackup -c|--client <cli_name>\n"
  printf "  or\n"
  printf "drlm listbackup -A|--all\n"
  printf "\n"
}

function listclienthelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm listclient [OPTARGS]" "List DRLM database clients"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to list"
  printf '%-25s %-45s\n' "-A|--all" "List all clients"
  printf '%-25s %-45s\n' "-U|--unsched" "List clients that have no scheduled jobs"
  printf '%-25s %-45s\n' "-p|--pretty" "Marks up clients in green and down clients in red"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm listclient -c|--client <cli_name>\n"
  printf "  or\n"
  printf "drlm listclient -A|--all\n"
  printf "\n"
}

function listnetworkhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm listnetwork [OPTARGS]" "List DRLM database networks"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-n|--netname <NET_NAME>" "Select Network to list"
  printf '%-25s %-45s\n' "-A|--all" "List all networks"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm listnetwork -n|--netname <net_name>\n"
  printf "  or\n"
  printf "drlm listnetwork -A|--all\n"
  printf "\n"
}

function modnetworkhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm modnetwork [OPTARGS]" "Change Network properties"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-I|--id <NET_ID>" "Select Network to change by ID"
  printf '%-25s %-45s\n' "-n|--netname <NET_NAME>" "Select Network to change by NAME"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-n|--netname <NET_NAME>" "Set new NAME, only if -I|--id is specified"
  printf '%-25s %-45s\n' "-g|--gateway <GATEWAY>" "Set new GATEWAY address to network"
  printf '%-25s %-45s\n' "-m|--mask <MASK>" "Assign new MASK to network"
  printf '%-25s %-45s\n' "-s|--server <SERVER>" "Assign new SERVER IP to network"
  printf '%-25s %-45s\n' "-e|--enable" "Enable network"
  printf '%-25s %-45s\n' "-d|--disable" "Disable network"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Example:\n$(tput sgr0)"
  printf "drlm modnetwork -I|--id <net_id> [ options ]\n"
  printf "  or\n"
  printf "drlm modnetwork -n|--netname <net_name> [ options ]\n"  
  printf "\n"
}

function delbackuphelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm delbackup [OPTARGS]" "Delete Backup(s) form DRLM"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client for backups deletion"
  printf '%-25s %-45s\n' "-I|--id <BKP_ID>" "Select Backup or Snap to delete by ID"
  printf '%-25s %-45s\n' "-A|--all" "Select all Backups for Client"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm delbackup -c|--client <CLI_NAME> -A|--all\n"
  printf "  or\n"
  printf "drlm delbackup -I|--id <BKP_ID>\n"
  printf "\n"
}

function runbackuphelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm runbackup [OPTARGS]" "Run remote client backup from DRLM"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to run backup by name"
  printf '%-25s %-45s\n' "-I|--id <CLI_ID>" "Select Client to run backup by ID"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-C|--config" "Select Client backup configuration"
  printf '%-25s %-45s\n' "-h|--help" "Show this help" 
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm runbackup -c|--client <cli_name>\n"
  printf "        or\n"
  printf "drlm runbackup -I|--id <cli_id>\n"
  printf "\n"
}

function deljobhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm deljob [OPTARGS]" "Delete Jobs fom Database"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to delete all it's jobs"
  printf '%-25s %-45s\n' "-J|--job_id <JOB_ID>" "Select Job to delete by ID"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm deljob -c|--client <cli_name>\n"
  printf "         or\n"
  printf "drlm deljob -I|--job_id <job_ID>\n"
  printf "\n"
}

function addjobhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm addjob [OPTARGS]" "Add Job to Database"
  printf "\n"
  printf "$(tput bold)Required Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client name of this job"
  printf '%-25s %-45s\n' "-s|--start_date <DATE>" "Start date of the job. Format: YYYY-MM-DDTHH:MM"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-e|--end_date <DATE>" "End date of the job. Format: YYYY-MM-DDTHH:MM"
  printf '%-25s %-45s\n' "-r|--repeat <REPEAT>" "Repeat schedule of the job. You can specify in min(s) or minute(s), hour(s), day(s), week(s), month(s) and year(s)"
  printf '%-25s %-45s\n' "-C|--config" "Select Client backup configuration"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm addjob -c|--client <cli_name> -s|--start_date 2017-01-30T21:00\n"
  printf "             or\n"
  printf "drlm addjob -c|--client <cli_name> -s|--start_date 2017-02-03T08:00 -e|--end_date 2017-02-05T23:00 -r|--repeat 1hour\n"
  printf "\n"
}

function listjobhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm listjob [OPTARGS]" "List DRLM database jobs"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-I|--job_id <JOB_ID>" "Select Job to list"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to list their jobs"
  printf '%-25s %-45s\n' "-A|--all" "List all jobs"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm listjob -J|--job_id <job_id>\n"
  printf "             or\n"
  printf "drlm listjob -c|--client <cli_name>\n"
  printf "             or\n"
  printf "drlm listjob -A|--all\n"
  printf "\n"
}

function schedjobhelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm sched [OPTARGS]" "Control DRLM job scheduler"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-e|--enable" "Enable one DRLM job or the DRLM scheduler"
  printf '%-25s %-45s\n' "-d|--disable" "Disable one DRLM job or the DRLM scheduler"
  printf '%-25s %-45s\n' "-r|--run" "Run planned jobs by date"
  printf '%-25s %-45s\n' "-I|--job_id <JOB_ID>" "Select Job to enable/disable"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm sched -e|--enable\n"
  printf "             or\n"
  printf "drlm sched -d -I <job_id>\n"
  printf "             or\n"
  printf "drlm sched -r|--run\n"
  printf "\n"
}

function expbackuphelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm expbackup [OPTARGS]" "Export DRLM DR file"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-I|--id <BKP_ID>" "Select Backup to export by ID"
  printf '%-25s %-45s\n' "-f|--file <FILE_NAME>" "Exportation filename"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm expbackup -I|--id <BKP_ID> -f|--file <DESTINATION_FILE>\n"
  printf "\n"
}

function impbackuphelp() {
  printf "\n"
  printf "\n"
  printf "$(tput bold)Usage:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "drlm impbackup [OPTARGS]" "Export DRLM DR file"
  printf "\n"
  printf "$(tput bold)Options:\n$(tput sgr0)"
  printf '%-25s %-45s\n' "-c|--client <CLI_NAME>" "Select Client to import backup"
  printf '%-25s %-45s\n' "-f|--file <FILE_NAME>" "Importation filename"
  printf '%-25s %-45s\n' "-I|--id <BKP_ID>" "Select Backup ID from which is going to import the backup"
  printf '%-25s %-45s\n' "-C|--config" "Select client backup configuration name in store"
  printf '%-25s %-45s\n' " " "If configuration is not set is used 'default' value"
  printf '%-25s %-45s\n' "-t|--type" "Select backup type to import (0: DataOnly, 1: Recover PXE, 2: Recover ISO)"
  printf '%-25s %-45s\n' " " "If type is not set is used '1' value (Recover PXE)"
  printf '%-25s %-45s\n' "-k|--key <ENCRYPT KEY>" "Encryption key of the imported DR file"
  printf '%-25s %-45s\n' "-K|--key-file <KEY FILE>" "Route to a file that contains the"
  printf '%-25s %-45s\n' " " "encryption key of the imported DR file"
  printf '%-25s %-45s\n' "-h|--help" "Show this help"
  printf "\n"
  printf "$(tput bold)Examples:\n$(tput sgr0)"
  printf "drlm impbackup -c|--client <CLI_NAME> -f|--file <FILE_NAME>\n"
  printf "drlm impbackup --client <CLI_NAME> --file <FILE_NAME> -t 0 -C DataOnlyHomeBackups\n"
  printf "\n"
}
